﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI.HtmlControls;

namespace GridsOffice.Models
{
    public class DocumentViewer
    {
        public DocuViewareRESTOutputResponse GetDocuViewareControl()
        {
            //DocuVieware™ object is handled in a using statement so the object is automatically disposed
            //when the control has been rendered and sent to client. It is very important to do so
            //otherwise every DocuVieware™ object that will be created here
            //will pile up causing an important memory leak that will eventually cause a memory outage.
            using (GdPicture14.WEB.DocuVieware docuVieware = new GdPicture14.WEB.DocuVieware())
            {
                docuVieware.ID = "DocuVieware1" + DateTime.Now.Millisecond.ToString();
                docuVieware.Timeout = MvcApplication.SESSION_TIMEOUT;
                docuVieware.Height = new System.Web.UI.WebControls.Unit("100%");
                docuVieware.Width = new System.Web.UI.WebControls.Unit("100%");
                docuVieware.DisableAnnotationDrawingModePanel = true;
                docuVieware.SinglePageView = false;
                docuVieware.ForceScrollBars = false;
                docuVieware.AllowedExportFormats = "*";
                docuVieware.MaxUploadSize = 52428800;
                docuVieware.CollapsedSnapIn = true;
                docuVieware.EnableMouseModeButtons = false;
                docuVieware.EnableFileUploadButton = false;
                docuVieware.EnableLoadFromUriButton = false;
                docuVieware.EnablePrintButton = true;
                docuVieware.EnableSaveButton = true;
                docuVieware.ShowThumbnailsSnapIn = true;
                docuVieware.ShowBookmarksSnapIn = false;
                docuVieware.ShowTextSearchSnapIn = false;
                docuVieware.ShowAnnotationsSnapIn = true;
                docuVieware.EnableTwainAcquisitionButton = true;
                docuVieware.EnableThumbnailDragDrop = true;
                docuVieware.EnableLoadFromUriButton = true;
                docuVieware.EnableFileUploadButton = true;
                var control = new System.Web.UI.HtmlControls.HtmlGenericControl("svg");
                control.Attributes["width"] = "100%";
                control.Attributes["height"] = "100%";
                control.Attributes["viewBox"] = "0 0 16 16";
                control.InnerHtml = "<path d='M16 6.204l-5.528-0.803-2.472-5.009-2.472 5.009-5.528 0.803 4 3.899-0.944 5.505 4.944-2.599 4.944 2.599-0.944-5.505 4-3.899z'></path>";
                docuVieware.AddCustomToolbarButton("Test", "test", control, "showModalClick();");

                using (StringWriter controlOutput = new StringWriter())
                {
                    docuVieware.RenderControl(controlOutput);
                    DocuViewareRESTOutputResponse output = new DocuViewareRESTOutputResponse
                    {
                        HtmlContent = controlOutput.ToString()
                    };
                    return output;
                }
            }
        }
    }

    public class DocuViewareRESTOutputResponse
    {
        public string HtmlContent { get; set; }
    }
}