﻿using GdPicture14;
using GdPicture14.WEB;
using GridsDAL;
using GridsDAL.DataModel.OtherModels;
using GridsOffice.Models;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web;
using System.Web.Hosting;
using System.Web.Mvc;
using static System.Net.Mime.MediaTypeNames;

namespace GridsOffice.Controllers
{
    [AllowAnonymous]
    public class ScanController : BaseController
    {
        public GdPictureImaging _oGdPictureImaging = new GdPictureImaging();
        // GET: Scan
        public ActionResult Index(int InstrumentID)
        {
            var instrument = db.Instruments.Find(InstrumentID);

            GRIDSInstrument objInstrument = new GRIDSInstrument();
            objInstrument.Act = instrument.Act;
            objInstrument.IndexID = instrument.OfficeID.Value;
            objInstrument.DocYear = instrument.DocYear;
            objInstrument.InstrumentID = instrument.InstrumentID;
            ViewBag.instrumentRecord = objInstrument;
			ViewBag.batchId = 1;
			
            var documentViewer = new DocumentViewer();
            var data = documentViewer.GetDocuViewareControl();
            ViewBag.gdPictureView = data.HtmlContent;
			
			
            return View();
        }

        public static void StartScan(CustomActionEventArgs e)
        {
            GRIDSInstrument instrument = new GRIDSInstrument();
            instrument = JsonConvert.DeserializeObject<GRIDSInstrument>(e.args.ToString());
            string path = "";
            bool disposeImage = false;
            ScanController obj = new ScanController();
            var dtInst = obj.GetInstrumentWithYear(instrument.Act, instrument.IndexID, instrument.DocYear.ToString());
            string _documentName = dtInst.ToList().FirstOrDefault().NextDocName;
            
            path = @"D:\GitProjects\GRIDSApp\GridsScanning\GridsScanning\ScannedDocs\";
            if (!Directory.Exists(path))
            {
                Directory.CreateDirectory(path);
            }
            path += _documentName;
            GRIDSPartialBatchDocument gRIDSBatchDocument = new GRIDSPartialBatchDocument();
            using (GdPictureImaging gdpictureImaging = new GdPictureImaging())
            {
                int imageId = 0;
                var d = e.docuVieware.GetDocumentType();
                GdPictureStatus status;
                // First we need to know what kind of document we are dealing with
                switch (e.docuVieware.GetDocumentType())
                {
                    // If it is an image...
                    case DocumentType.DocumentTypeBitmap:
                        status = e.docuVieware.GetNativeImage(out imageId);
                        break;
                    // If it is a PDF document...
                    case DocumentType.DocumentTypePDF:
                        status = e.docuVieware.GetNativePDF(out GdPicturePDF gdPicturePdf);
                        if (status == GdPictureStatus.OK)
                        {
                            // ...we need to rasterize it to obtain an actual image
                            imageId = gdPicturePdf.RenderPageToGdPictureImageEx(200, false);
                            disposeImage = true;
                        }
                        break;
                    default:
                        status = GdPictureStatus.Aborted;
                        break;
                }
                if (status == GdPictureStatus.OK)
                {
                    gdpictureImaging.TiffSaveAsMultiPageFile(imageId, path, TiffCompression.TiffCompressionCCITT4);
                    gdpictureImaging.TiffCloseMultiPageFile(imageId);
                    gdpictureImaging.ReleaseGdPictureImage(imageId);
                    gdpictureImaging.TwainCloseSource();
                    string documentBatchId = obj.SaveDocument(_documentName, instrument.BatchId.ToString(), instrument.IndexID.ToString(), instrument.Act.ToString(), e.docuVieware.PageCount, "SCAN");

                    gRIDSBatchDocument.ScanningPath = path;
                    gRIDSBatchDocument.BatchDocumentID = documentBatchId;
                    gRIDSBatchDocument.message = "Success";
                    gRIDSBatchDocument.BatchID = instrument.BatchId.ToString();
                    e.result = gRIDSBatchDocument;
                }
                else
                {
                    gRIDSBatchDocument.message = "Failure";
                    e.result = gRIDSBatchDocument;
                }
            }
        }
    }
}